#ifndef LSTOOLS_H
#define LSTOOLS_H

#define LSTOOLS_REV 0

typedef int (*lsAtVarProc)(char *dest,int maxchars,LPCSTR src,LPARAM lParam);

typedef struct _lsBangCmdDef {
	LPCSTR Name;
	BangCommand *Command;
} lsBangCmdDef;

void LSReplaceAtVars(char *dest,int maxchars,const char *src,
                   lsAtVarProc LookupVar, LPARAM lParam);


#ifndef ASSERT
#ifndef NDEBUG
#ifdef NOISY_ASSERT
#define ASSERT(n) if (!(n)) {char buf[MAX_LINE_LENGTH];\
sprintf(buf,"Assert failed at line %d of %s:\n  %s\nBreak to debug?",__LINE__,__FILE__,#n);\
if(MessageBox(NULL,buf,MODULE,MB_YESNO)==IDYES) DebugBreak();}
#else
#define ASSERT(n) if (!(n)) LSLogPrintf(LOG_ERROR,MODULE,"Assert failed at line %d of %s: %s",__LINE__,__FILE__,#n)
#endif
#else
#define ASSERT(n) (void)0
#endif
#endif

#ifndef WRITEABLE
#define WRITEABLE(ptr,len) (ptr!=NULL && !IsBadWritePtr(ptr,len))
#define READABLE(ptr,len) (ptr!=NULL && !IsBadReadPtr(ptr,len))
#define EXECABLE(ptr) (ptr!=NULL && !IsBadCodePtr((int(__stdcall*)(void))ptr))
#endif

#endif /* LSTOOLS_H */ 
